/*
* Copyright 2021 E.J.I.E., S.A.
*
* Licencia con arreglo a la EUPL, Versión 1.1 exclusivamente (la «Licencia»);
* Solo podrá usarse esta obra si se respeta la Licencia.
* Puede obtenerse una copia de la Licencia en
*
* http://ec.europa.eu/idabc/eupl.html
*
* Salvo cuando lo exija la legislación aplicable o se acuerde por escrito,
* el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
* SIN GARANT�?AS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
* Véase la Licencia en el idioma concreto que rige los permisos y limitaciones
* que establece la Licencia.
*/
package com.ejie.ad74a.service.tramitacion;

import java.util.Date;

import com.ejie.ad74a.model.BandejaPapel0;
import com.ejie.ad74a.model.BandejaTelematica;
import com.ejie.ad74a.model.Expedientes;
import com.ejie.ad74a.model.TramitesExpediente;
import com.ejie.ad74a.util.constantes.TareasEnum;
import com.ejie.ad74a.ws.client.platea.model.task.Task;
import com.ejie.ad74a.ws.client.platea.tareasTramitacion.TWait;
import com.ejie.ad74a.ws.client.platea.tareasTramitacion.TWaitType;

/**
 * Gestión de los procesos comunes a los trámites y tareas
 * 
 * @author IBERMATICA
 */

public interface TramitacionService {

	void tratamientoTramiteTareaSugerida(Task task, String numRegistro, Expedientes expediente) throws Throwable;

	void tratamientoTramiteTareaEjecutada(Task task, Boolean automatica) throws Throwable;

	void tratamientoTramiteTareaCancelada(Task task) throws Throwable;

	TramitesExpediente tratamientoTramiteBandeja(BandejaTelematica bandeja, String idTareaFicticia, TareasEnum tareaE,
			String estado) throws Throwable;

	TramitesExpediente tratamientoTramiteBandejaPapel0(BandejaPapel0 bandeja, String idTareaFicticia, TareasEnum tareaE,
			String estado) throws Throwable;

	void sugerirTarea(Expedientes expediente, TareasEnum tarea) throws Throwable;

	void sugerirTarea(Task task, TareasEnum tarea) throws Throwable;

	TramitesExpediente createNoPlateaTramite(Expedientes expediente, String idTarea, TareasEnum tareaE,
			String estadoTramite, String estadoTarea, String numRegistro, Date fechaRegistro) throws Throwable;

	void finalizarTareaComunicacionInforme(String folderId) throws Throwable;

	void finalizarTareaEstudio(String folderId, String estadoFinalizacion) throws Throwable;

	void finalizarEspera(String folderId, TWaitType tipoEspera, String valorFinalizacion);

	TWait getWaitByType(String folderId, TWaitType tipoEspera);

	void cancelarTareasSugeridas(String folderId, TareasEnum tareaActual);

	void cancelarTareaSugerida(String taskGUID);

	/**
	 * Proceso a ejecutar al sugerirse una tarea (una vez recibido el evento de
	 * tarea sugerida). Crear el registro del trámite y el registro de la tarea en
	 * BD
	 */
	void tratamientoTramiteTareaAutomaticaSugerida(Task task, String numRegistro, Expedientes expediente)
			throws Throwable;
}
